关于java的try-catch

代码如下


public class TestException {
	public static void main(String[] args) {
		try {
			//throw new Exception("Nothing");
			throw new Error("nothing");// 切换这两行试试??
		} catch (Exception e) {
			System.out.println("捕获到异常。。");
			e.printStackTrace(System.err);
		}finally{
			System.out.println("finally 语句。。");
		}
		//
		System.out.println("try 外部的后面的代码。。。");
	}
}

说明:

1. try的意思,就是试着执行里面的语句,所以如果try内部抛出了异常 Exception,那么,将会执行catch 部分,以及try 外边的后面的语句。

2. 如果 try 内部出现了Error,表示出错,后面的语句就不执行了,catch也抓不住。

3. 但是如果有 finally块的话,那么,finally 几乎是必定会执行的,但是这里有一个先后顺序的问题,应该是 finally 块和 打印异常堆栈将会在另外一个线程之中执行,所以 打印的顺序就很有意思了。

4. 如果在try或者catch之中,执行System.exit(0); 那么 finally不会被执行,此外的情况,不管是Error还是return,finally块都会执行到。

5. 建议不清楚的拷贝代码或者自己写一份执行了看看。


发布了112 篇原创文章 · 获赞 1688 · 访问量 530万+
展开阅读全文

没有更多推荐了,返回首页

©️2019 CSDN 皮肤主题: 编程工作室 设计师: CSDN官方博客

分享到微信朋友圈

×

扫一扫,手机浏览